;----------------------------------------------------------------------------
; Init Include ProgData
;----------------------------------------------------------------------------

DisplayFmt     PROTO :DWORD
GetWindowsOS   PROTO :PTR BYTE
DisplayAt      PROTO x:DWORD, y:DWORD, StringBuffer:DWORD, len:DWORD
SetColorTo     PROTO ForeGroundColor:DWORD, BackGroundColor:DWORD
ConvertToWin   PROTO :DWORD, :DWORD, :DWORD
ReadChosenFile PROTO :DWORD, :DWORD 
PopBox         PROTO PtrBoxTitle:DWORD, PtrBoxMessage:DWORD 
SaveScreen     PROTO :DWORD
SaveChosenFile PROTO :DWORD, :DWORD
AxCPUid        PROTO :DWORD
FormatNum      PROTO :DWORD
AssignStr      PROTO PtrDest:DWORD, PtrSource:DWORD, MaxLen:DWORD
AlexConvertArea      PROTO  :DWORD, :DWORD,  :DWORD
SaveArea       PROTO :DWORD, :WORD, :WORD, :WORD, :WORD 
DisplayArea    PROTO :DWORD, :WORD, :WORD, :WORD, :WORD
 

;----------------------------------------------------------------------------
; Numeric constants used by the program
;----------------------------------------------------------------------------

Zero          EQU 0                  ;initial position on the buffer
One           EQU 1
Two           EQU 2                  ;To get the buffer size from chars num
Four          EQU 4                  ;number of initial bytes to read
Six           EQU 6
Seven         EQU 7
Eight         EQU 8
N16           EQU 16
N32           EQU 32 
N64           EQU 64
N128          EQU 128
AlgoRowInit   EQU Six
CR            EQU 13
LF            EQU 10

ON            EQU One
OFF           EQU Zero

TestToDo      EQU Four

MaxRows       EQU 40                 ;Max Rows of Console Display Mode 12
MaxCols       EQU 90                 ;Max Cols of Console Display Mode 24

CharNumber    EQU MaxRows * MaxCols

NumCycles     EQU MaxRows * MaxCols / Two

BytesToRead   EQU CharNumber * Two

MaxSize       EQU MaxRows * MaxCols * Four      ;Max buffer size Display Mode 12


TestAreaMaxCols  EQU  43
TestAreaMaxRows  EQU  23

TestAreaRowInit  EQU  AlgoRowInit
TestAreaRowEnd   EQU  36
TestAreaColInit  EQU  46
TestAreaColEnd   EQU  88

MaxLenCpuDesc    EQU  80

RowCpuDesc1      EQU  Two

ColCpuDesc       EQU  Seven

OSCol            EQU  Seven
OSRow            EQU  One

ColAlgoToTest    EQU  ColCpuDesc

TestAreaChars    EQU  TestAreaMaxCols * TestAreaMaxRows

ColTicksDisplacement   EQU 11  
ColTicksInit           EQU 46    


RowTimeStamp     EQU Zero
ColTimeStamp     EQU 63
LenTimeStamp     EQU 24
Colon            EQU 58 


PRODUCT_PROFESSIONAL EQU 30h ; defined in WinNT.h Windows SDK 7.0A

; ----------------------------------------------------------------
;  Console code colors  
; ----------------------------------------------------------------


DarkBlue     EQU One

DarkBlack    EQU Zero
DarkBlue     EQU One
DarkGreen    EQU Two
DarkCyan     EQU 3
DarkRed      EQU Four
DarkMagenta  EQU 5
DarkBrown    EQU Six
DarkWhite    EQU Seven

BrightGray    EQU Eight
BrightBlue    EQU 9
BrightGreen   EQU 10
BrightCyan    EQU 11
BrightRed     EQU 12
BrightMagenta EQU 13
BrightYellow  EQU 14
BrightWhite   EQU 15

;----------------------------------------------------------------


; ----------------------------------------------------------------
;  Keyboard keys   
; ----------------------------------------------------------------

ArrowUp     EQU 72
ArrowDown   EQU 80
ArrowRight  EQU 77
ArrowLeft   EQU 75
PagDown     EQU 81
PagUp       EQU 73
Home        EQU 71
EndKey      EQU 79
EnterKey    EQU 13        




R_Key       EQU 82
r_Key       EQU 114
S_Key       EQU 83
s_Key       EQU 115
V_Key       EQU 86
v_Key       EQU 118
C_Key       EQU 67 
c_Key       EQU 99
E_Key       EQU 69
e_Key       EQU 101
H_Key       EQU 72
h_Key       EQU 104
I_Key       EQU 73
i_Key       EQU 105

OK          EQU 6
YES         EQU One
NO          EQU Zero

;----------------------------------------------------------------------------
; Initialized data
;----------------------------------------------------------------------------

.data

ALIGN 4

    Month   db   "Jan-"
            db   "Feb-"
            db   "Mar-"
            db   "Apr-"
            db   "May-"
            db   "Jun-"
            db   "Jul-"
            db   "Aug-"
            db   "Sep-"
            db   "Oct-"
            db   "Nov-"
            db   "Dec-"

    DayMin  db   "00"
            db   "01"
            db   "02"
            db   "03" 
            db   "04"
            db   "05"             
            db   "06"
            db   "07" 
            db   "08"
            db   "09" 
            db   "10"
            db   "11"
            db   "12"
            db   "13" 
            db   "14"
            db   "15"             
            db   "16"
            db   "17" 
            db   "18"
            db   "19" 
            db   "20"
            db   "21"
            db   "22"
            db   "23" 
            db   "24"
            db   "25"             
            db   "26"
            db   "27" 
            db   "28"
            db   "29" 
            db   "30"
            db   "31"
            db   "32"
            db   "33" 
            db   "34"
            db   "35"             
            db   "36"
            db   "37" 
            db   "38"
            db   "39" 
            db   "40"
            db   "41"
            db   "42"
            db   "43" 
            db   "44"
            db   "45"             
            db   "46"
            db   "47" 
            db   "48"
            db   "49" 
            db   "50"
            db   "51" 
            db   "52"
            db   "53" 
            db   "54"
            db   "55"             
            db   "56"
            db   "57" 
            db   "58"
            db   "59" 
    

    DayTimeStamp      db  "gg-"
    MonthTimeStamp    db  "mmm-"
    CenturyTimeStamp  db  "20"
    YearTimeStamp     db  "yy at "
    HourTimeStamp     db  "hh:"
    MinutesTimeStamp  db  "mm GMT",0

    PtrHourTimeStamp  dd  HourTimeStamp
    PtrMinutesTimeStamp   dd  MinutesTimeStamp
    PtrDayTimeStamp   dd  DayTimeStamp
    PtrYearTimeStamp  dd  YearTimeStamp
    PtrMonthTimeStamp dd  MonthTimeStamp

    

    BoxTitle    DB  "Program Message", 0
    BoxMessage  DB  "Sorry friend,",13,10,"This option is not",13,10
                DB  "Implemented yet, try in a few days",0 

    BoxMsgSaved DB  "Screen saved to Disk",0   

    BoxMsgErrSave DB "Error while saving File to Disk",0               

    BoxMsgErrFour DB  "Error while saving initial 4 bytes to Disk",0 

    BoxMsgBack    DB  "Back from the operation",0

    BoxMsgStart   DB  "Start the operation",0

    RunAgain      DWORD Zero

    TopCode       BYTE  "[code]",13,10,0
    BottomCode    BYTE  "[/code]",13,10,0 

      
    ExitMessage DB  "Confirm exit the program ?",0
    ExitTitle   DB  "Exit Program",0   

    CaptionRead   BYTE  "Open a Screen File to Display",0

    CaptionSave   BYTE  "Save a Screen File to Disk",0
    
    szFilter      BYTE  "POP files *.pop",0,"*.pop",0,0

    BufFileBytes  dd   BytesToRead  ;buffer size to read the POP file


;---------------------------------------------------------------------------------

    Sep         DB  ",",0   ;   used for decimal numbers separator - choose yours
    lpSep       DD  Sep     ;   When calling GetNumberFormat
    Tsep        DD  ".",0   ;   used for thousand numbers separator - choose yours
    lpTsep      DD  Tsep    ;   When calling GetNumberFormat

;---------------------------------------------------------------------------------

    PtrBufNum        DD BufNum



    AlgoDesc         BYTE  31 DUP (?)    
    AlgoDescSize     DWORD SIZEOF AlgoDesc
    

    
    AlgoSizeStr       BYTE  9 DUP (?)
    PtrAlgoSizeStr    DWORD AlgoSizeStr
    AlgoSizeStrLen    DWORD ?
    PtrAlgoSizeStrLen DWORD ?
    AlgoTicks         DWORD ?
    AlgoTicksStr      BYTE  10 DUP (?)
    PtrAlgoTicksStr   DWORD AlgoTicksStr    
    AlgoRow           DWORD AlgoRowInit
    AlgoColDesc       DWORD 4
    AlgoColSize       DWORD 40
    AlgoColTicks      DWORD 46
    StringLenght      DWORD ?

    TestDone          DWORD 0

    MaxLenStr         DWORD 32

    CpuDesc1          BYTE 81 dup (0)

    PtrTextResults    DWORD TextResults  





;----------------------------------------------------------------------------
; Include Screen to display - precompiled db for Main Screen Display Mode 16
;----------------------------------------------------------------------------  

include TestB16.inc

   
          
;----------------------------------------------------------------------------
; Uninitialized data
;----------------------------------------------------------------------------         

.data?

    ALIGN N16

    ConsoleScreen16 CHAR_INFO CharNumber dup (<>)

    SecurityArea  db   N16 dup (?)

    ALIGN N16

    FileScreen    CHAR_INFO CharNumber dup (<>)

    SecurityArea0 db   N16 dup (?)

    ALIGN N16

    SavedScreen   CHAR_INFO CharNumber dup (<>)

    SecurityArea1 db   N16 dup (?)

    ALIGN N16

    TextResults   BYTE CharNumber + N128 dup (?)   

    SecurityArea2 db   N16 dup (?)

    ALIGN N16

    ResultScreen  CHAR_INFO CharNumber dup (<>)   

    SecurityArea3 db   N16 dup (?)

    ALIGN N16

    HelpScreen    CHAR_INFO CharNumber dup (<>)   

    SecurityArea4 db   N16 dup (?)

    ALIGN N16

    InfoScreen    CHAR_INFO CharNumber dup (<>)   

    SecurityArea5 db   N16 dup (?)

    ALIGN N16

    TestAreaBuffer CHAR_INFO TestAreaChars dup (<>) 

    SecurityArea6 db   N16 dup (?)



    RowInitialFile    db   ?    
    RowFinalFile      db   ?    
    ColInitialFile    db   ?   
    ColFinalFile      db   ?  

    OddNumber     dd   ?

    ChosenColor   dd   ?
    ActualColor   dd   ? 

    Lenght        dd   ?
    Lenght1       dd   ?
    Lenght2       dd   ?        
        
  

    R1            dw   ?
    R2            dw   ?
    C1            dw   ?
    C2            dw   ?
    

    BufRows       dw   ?          ;buffer height (rows)
    BufCols       dw   ?          ;buffer width (columns)
    BufChars      dd   ?          ;number of chars in the buffer

    FileBuffer2   db   BytesToRead  dup (?)
    HelpBuffer    db   BytesToRead  dup (?)   
    InfoBuffer    db   BytesToRead  dup (?)      


    PtrFileName   DWORD ?   

    hFile     HANDLE ? 
    cci       CONSOLE_CURSOR_INFO <>        


    wHnd      HANDLE ? 
    rHnd      HANDLE ?

    windowSize SMALL_RECT <> ; Structures used to Read
    bufferSize COORD      <> ; and Write to the Screen
    startPoint COORD      <> ; the whole screen

    TestAreaWindowSize SMALL_RECT <> ; Structures used to Read
    TestAreaBufferSize COORD      <> ; and Write to the Screen
    TestAreaStartPoint COORD      <> ; the Test Area Screen 

    

    howmany dd ?
    buffer  INPUT_RECORD <>

    OSVERSIONINFOEX_NEW STRUCT
      dwOSVersionInfoSize   DWORD ?
      dwMajorVersion        DWORD ?
      dwMinorVersion        DWORD ?
      dwBuildNumber         DWORD ?
      dwPlatformId          DWORD ?
      szCSDVersion          BYTE  128  dup (?)
      wServicePackMajor     WORD  ?
      wServicePackMinor     WORD  ?
      wSuiteMask            WORD  ?
      wProductType          BYTE  ?
      wReserved             BYTE  ?
    OSVERSIONINFOEX_NEW ENDS

    CTEXT MACRO text:VARARG
      LOCAL TxtName
      .DATA
        TxtName BYTE text,0
      .CODE
      EXITM <ADDR TxtName>
    ENDM

    szOS   BYTE   256 dup (?)

    CpuBuffer BYTE 260 dup (?)
    pbuf   DWORD ?

    PtrCpuBuf2   DWORD ?

  

    ConfirmExit      dd ?
    ButtonClicked    dd ?

    DisplayFlag      dd ?

    TextString       BYTE 64 dup (?)
    PtrTextString    dd ?

    AlgoNum          dd ?

    BufNum           DB  255 dup(?)     ; used by GetNumberFormat
    NumFmt           NUMBERFMT <>       ; to format with thousand separator integer 
                                        ; numbers

;----------------------------------------------------------------------------
; End Include ProgData
;----------------------------------------------------------------------------
